﻿using UnityEngine;
using System.Collections;

public class Demo_menu : MonoBehaviour 
{
	public DaggerfallWorkshop.WorldTime worldTime;
	public DaggerfallWorkshop.Demo.PlayerMouseLook mouselook;
	public DaggerfallWorkshop.Demo.PlayerMotor playerMotor;
	public Light torchLight;
	public EnhancedSky.SkyManager skyManager;
	public DaggerfallWorkshop.Demo.SongManager songManager;
	public DaggerfallWorkshop.StreamingWorld streamingWorld;

	//Show meny
	private bool showMenu = false;
	private bool showConfirm = false;

	//Controls
	private bool invertMouse = false;
	private bool highSpeed = false;

	//Time
	private float timeScale = 1;

	//Graphics
	private bool brighterTorch = true;
	private bool UseEnhancedSky = true; 

	//Other
	private bool playMusic = true;
	private bool showDedugText = false;

	//Size variabels
	float native_width = 1280;
	float native_height = 720;
	float adjustedHeight = 0;

	void LateUpdate()
	{
		if(Input.GetKeyUp(KeyCode.Tab))
		{
			if(showConfirm)
				showConfirm = false;
			else if(showMenu)
			{
				showMenu = false;
				mouselook.enabled = true;
				Cursor.lockState = CursorLockMode.Locked;
				Cursor.visible = false;
			}
			else
			{
				showMenu = true;
				mouselook.enabled = false;
				Cursor.lockState = CursorLockMode.None;
				Cursor.visible = true;
			}
		}
	}

	void OnGUI ()
	{
		if(showConfirm || showMenu)
		{
			if((float)Screen.width/(float)Screen.height > 1.6)
			{
				native_width = 1280;
				native_height = 720;
				adjustedHeight = 150;
			}
			else
			{
				native_width = 1024;
				native_height = 768;
				adjustedHeight = 0;
			}

			float rx = Screen.width / native_width;
			float ry = Screen.height / native_height;
			GUI.matrix = Matrix4x4.TRS (new Vector3(0, 0, 0), Quaternion.identity, new Vector3 (rx, ry, 1)); 
		}

		if(showConfirm)
		{
			GUI.Box(  new Rect(290+adjustedHeight,200, 450, 220)  , "" );

			GUI.Label(new Rect(340+adjustedHeight,250,180,40),"Are you sure you want to quit?");

			if(GUI.Button(new Rect(320+adjustedHeight,330,140,40), "Confirm"))
			{
				Application.Quit();
			}

			if(GUI.Button(new Rect(540+adjustedHeight,330,140,40), "Cancel"))
			{
				showConfirm = false;
			}
		}

		else if(showMenu)
		{
			GUI.Box(  new Rect(310+adjustedHeight, 80, 400, 500)  , "" );
		
			GUI.Label(new Rect(370+adjustedHeight,110,120,40),"Controls");
			invertMouse = GUI.Toggle(new Rect(390+adjustedHeight,140,220,20),invertMouse, "Toggle mouse invert on/off");
			highSpeed = GUI.Toggle(new Rect(390+adjustedHeight,170,220,20),highSpeed, "Toggle high speed running on/off");
		
			GUI.Label(new Rect(370+adjustedHeight,210,120,40),"TimeScale");

			GUI.Label(new Rect(390+adjustedHeight,240,220,40),"Timescale");
			timeScale = GUI.HorizontalSlider(new Rect(390+adjustedHeight,265,220,40),timeScale,0.0f,8.0f);

			GUI.Label(new Rect(370+adjustedHeight,290,120,40),"Graphics");
			UseEnhancedSky  = GUI.Toggle(new Rect(390+adjustedHeight,320,220,20),UseEnhancedSky , "Toggle Enhanced Sky on/off");
			brighterTorch = GUI.Toggle(new Rect(390+adjustedHeight,350,320,20),brighterTorch, "Toggle brighter torch on/off");

			GUI.Label(new Rect(370+adjustedHeight,390,120,40),"Other");
			playMusic = GUI.Toggle(new Rect(390+adjustedHeight,420,220,20),playMusic, "Toggle songs on/off");
			showDedugText = GUI.Toggle(new Rect(390+adjustedHeight,450,220,20),showDedugText, "Toggle debug text on/off");

			if(GUI.Button(new Rect(410+adjustedHeight,500,220,40), "Quit Game"))
			{
				showConfirm = true;
			}

			//Triggers if any settings are changed
			if (GUI.changed)
			{
				//Apply all the options below 
				worldTime.TimeScale = timeScale*250; 
				mouselook.invertMouseY = invertMouse;

				if(highSpeed)
					playerMotor.runSpeed = 240.0f;
				else
					playerMotor.runSpeed = 11.0f;

				if(brighterTorch)
					torchLight.enabled = true;
				else 
					torchLight.enabled = false;

				if(UseEnhancedSky)
				{
					skyManager.enhancedSkyToggle = true;
				}
				else
				{
					skyManager.enhancedSkyToggle = false;
				}

				if(playMusic)
				{
					if(!songManager.SongPlayer.IsPlaying)
						songManager.TogglePlay();
				}
				else
				{
					if(songManager.SongPlayer.IsPlaying)
						songManager.TogglePlay();
				}

				if(showDedugText)
				{
					streamingWorld.ShowDebugString = true;
				}
				else
				{
					streamingWorld.ShowDebugString = false;
				}
					
			}
		}

	}

}
